=== debian/changelog ===
libsbml (5.4.1-3) unstable; urgency=low

  * debian/control: removed dependency on swig2.0 (Closes: #667652)
    thanks to Peter Green for the hint.
  * debian/control: added myself to uploaders

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 05 Apr 2012 18:44:30 +0200

libsbml (5.4.1-2) unstable; urgency=low

  * added a patch to correct misspelled words in th source
  * debian/rules:
    added some lines to remove almost all lintian remarks
  * debian/*.docs:
    added, to have an upstream changelog in every package
  * debian/docs:
    removed, is not used anymore

 -- Ivo Maintz <ivo@maintz.de>  Fri, 30 Mar 2012 14:44:30 +0200

libsbml (5.4.1-1) unstable; urgency=low

  [ Ivo Maintz ]
  * update from upstream (Closes: #665837)
  * debian/control.in: added swig to libsbml5-python dependencies
  * debian/README.source:
    added some information
  * debian/rules:
    - added code to create a debian/libsbml5-octave.install file
      dependent on the install dircetory of the octave files
    - enhanced shlibdeps checking to remove the hardcoded dependency
      to libc6
      Closes: #659808
  * debian/dirs:
    deleted
  * debian/libsbml5-octave.install:
    deleted

  [ Andreas Tille ]
  * debian/control:
    - Added Homepage field
    - Versioned debhelper dependency
  * debian/compat: 8
  * debian/rules:
     - remove useless dh_make boilerplate
     - adapt get-orig-source target to what is written
       in README.source and removed older repackaging
       code
  * mv debian/README.Debian-source debian/README.source
  * debian/docs: No point in installing debian/README.source
  * delete advise about how to get the source tarball in favour
    of the code written in debian/rules:get-orig-source target
  * debian/upstream: citation information

 -- Ivo Maintz <ivo@maintz.de>  Thu, 29 Mar 2012 18:04:00 +0200

libsbml (5.4.0-1) UNRELEASED; urgency=low

  * update from upstream
  * removed the libsbml5-*-doc packages; the docu don't compile
    with doxygen > 1.6.3
  * moved libsbml5-matlab to contrib

 -- Ivo Maintz <ivo@maintz.de>  Tue, 21 Feb 2012 10:43:20 +0100

libsbml (5.3.0-1) UNRELEASED; urgency=low

  * update from upstream

 -- Ivo Maintz <ivo@maintz.de>  Thu, 12 Jan 2012 12:15:56 +0100
