=== debian/control ===
Source: libsbml
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ivo Maintz <ivo@maintz.de>,
 Changyan Xie <panchoat@gmail.com>,
 Moriyoshi Koizumi <mozo@sfc.keio.ac.jp>,
 Andreas Tille <tille@debian.org>,
 Thorsten Alteholz <debian@alteholz.de>
DM-Upload-Allowed: yes
Build-Depends: autoconf,
 automake,
 debhelper (>= 8),
 swig (>= 2),
 ruby1.8,
 libxml2-dev,
 python-dev,
 ruby1.8-dev,
 perl,
 libperl-dev,
 default-jdk | openjdk-6-jdk | java-gcj-compat-dev | java-sdk,
 octave-pkg-dev,
 python-support,
 graphviz,
 zlib1g-dev,
 libbz2-dev,
 mono-devel,
 mono-gmcs,
 cli-common-dev,
 cli-runtime
Standards-Version: 3.9.3
Section: science
Homepage: http://www.sbml.org/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/libsbml/trunk/
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/libsbml

Package: libsbml5-dev
Section: libdevel
Provides: libsbml-dev
Conflicts: libsbml3-dev
Architecture: any
Depends: libsbml5 (= ${binary:Version}),
 ${misc:Depends}
Description: System Biology Markup Language library - development files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains files necessary for development with libsbml.

Package: libsbml5-dbg
Section: debug
Priority: extra
Provides: libsbml-dbg
Conflicts: libsbml3-dbg
Architecture: any
Depends: libsbml5 (= ${binary:Version}), ${misc:Depends}
Description: System Biology Markup Language library - debug symbols
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains th debugging symbols for libsbml.

Package: libsbml5
Section: libs
Architecture: any
Provides: libsbml
Conflicts: libsbml1, libsbml2, libsbml3
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: System Biology Markup Language library
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.

Package: libsbml5-python
Section: python
Provides: python-sbml,
 libsbml-python
Conflicts: python-sbml3,
 libsbml4-python,
 libsbml-python
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 siwg2.0 | swig (>= 2)
Description: System Biology Markup Language library - Python bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Python bindings of LibSBML.

Package: libsbml5-matlab
Section: contrib/math
Provides: libsbml-matlab
Conflicts: libsbml4-matlab
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: System Biology Markup Language library - Matlab bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Matlab bindings of LibSBML.

Package: libsbml5-ruby1.8
Section: ruby
Provides: libsbml-ruby
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: System Biology Markup Language library - Ruby binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Ruby binding of LibSBML.

Package: libsbml5-java
Section: java
Provides: libsbml-java
Conflicts: libsbml3-java,
 libsbml4-java
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: System Biology Markup Language library - Java binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This Package contains the Java binding of LibSBML.

Package: libsbml5-perl
Section: perl
Provides: libsbml-perl
Conflicts: libsbml3-perl
Depends: ${shlibs:Depends},
 ${perl:Depends},
 ${misc:Depends}
Architecture: any
Description: System Biology Markup Language library - Perl binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Perl binding of LibSBML.

Package: libsbml5-octave
Section: math
Provides: libsbml-octave
Depends: ${shlibs:Depends},
 ${misc:Depends}
Architecture: any
Description: System Biology Markup Language library - Octave binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Octave binding of LibSBML.

Package: libsbml5-cil
Section: cli-mono
Provides: libsbml-cil
Depends: ${shlibs:Depends},
 ${misc:Depends}
Architecture: any
Description: System Biology Markup Language library - CLR binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the CLR binding of LibSBML.

Package: libsbml5-examples
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- example files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains C/C++, Java, Perl and layout examples.
