=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for libsbml

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

### part1 of a dirty hack for octave bindings, see install: section ###
OCTAVE_PATH ?= usr$(shell grep LOCALOCTFILEDIR config/makefile-common-vars.mk | tr -s ' ' ' ' | cut -d\  -f3)

# prevent the examples from beeing compressed...
DEB_COMPRESS_EXCLUDE := .xml .pdf .py .c .h .cpp .in .cs .java .pl .rb .xsl

version= $(shell dpkg-parsechangelog | grep Version | cut -d\  -f2 | cut -d- -f1)
major= $(shell dpkg-parsechangelog | grep Version | cut -d\  -f2 | cut -d. -f1)

libpack := libsbml
devpack := $(libpack)-dev
mathpack := $(libpack)-matlab
perlpack := $(libpack)-dev
pythonpack := $(libpack)-dev
javapack := $(libpack)-dev
debtmp := $(CURDIR)/debian/tmp
dbgpack := $(libpack)$(major)-dbg
SRC_TMP := $(CURDIR)/SRC_TMP
# Test for matlab
BIND_MATLAB := $(shell which matlab | grep -q matlab && echo '--with-matlab')

get-orig-source:
	uscan --verbose --force-download --repack

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
# prepare the debian/control file
	if [ "$(BIND_MATLAB)" = "--with-matlab" ] ; then \
	    sed -e 's/^#//'  debian/control.in > debian/control ; else \
	    grep -v ^# debian/control.in > debian/control ; fi

###-deactivated, because the docu only builds with doxygen-1.6.3-###
#				--with-doxygen				\

	./configure $(CROSS)	--prefix=/usr				\
				--with-perl				\
				--with-python				\
				--with-java				\
				--with-swig				\
				--with-ruby				\
				--with-octave				\
				$(BIND_MATLAB)				\
				--enable-layout				\
				--with-csharp				\
				--mandir=\$${prefix}/share/man		\
				--infodir=\$${prefix}/share/info	\
				CFLAGS="$(CFLAGS)"			\
				LDFLAGS="-Wl,-z,defs"			

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp
	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean
	### remove the by debian/rules created files ###
	rm -f debian/libsbml5-octave.install
	rm -f changelog
	### the clean target of the libsbml makefile is highly b0rken ###
	### verx ugly ###
	find src/bindings -name "*Glyph*" -exec rm -f {} +
	find * -type d -name .libs -exec rm -rf {} +
	find * -type f -name "*.o" -exec rm -f {} +
	find * -type f -name "*.so" -exec rm -f {} +
	find * -type f -name "*.class" -exec rm -f {} +
	find * -type f -name "*.exists" -exec rm -f {} +
	find * -type f -name "*.dll" -exec rm -f {} +
	find * -type f -name "*.jar" -exec rm -f {} +
	find * -type f -name "*.lo" -exec rm -f {} +
	find * -type f -name "Makefile" -exec rm -f {} +
	find * -type f -name "*.la" -exec rm -f {} +
	find * -type f -name "*.pyc" -exec rm -f {} +
	find * -type l -exec rm -f {} +
	rm -rf config.sub config.guess docs/src/perlmod src/bindings/csharp/libsbmlcs.snk src/bindings/matlab/TranslateSBML.mexa64 \
	src/bindings/matlab/OutputSBML.mexa64 src/bindings/octave/TranslateSBML.mex src/bindings/octave/OutputSBML.mex \
	src/bindings/perl/pm_to_blib src/bindings/perl/LibSBML.bs src/bindings/perl/blib/arch/auto/LibSBML/LibSBML.bs \
	src/bindings/csharp/libsbml_wrap-win.h src/bindings/csharp/csharp-files/BoundingBox.cs \
	src/bindings/csharp/csharp-files/CubicBezier.cs src/bindings/csharp/csharp-files/Curve.cs \
	src/bindings/csharp/csharp-files/Dimensions.cs src/bindings/csharp/csharp-files/GraphicalObject.cs \
	src/bindings/csharp/csharp-files/Layout* src/bindings/csharp/csharp-files/LineSegment.cs \
	src/bindings/csharp/csharp-files/ListOfGraphicalObjects.cs src/bindings/csharp/csharp-files/ListOfLayouts.cs \
	src/bindings/csharp/csharp-files/ListOfLineSegments.cs src/bindings/csharp/csharp-files/Point.cs \
	src/bindings/csharp/local-downcast-extension.i src/bindings/csharp/local-downcast-namespaces.i src/bindings/csharp/local-downcast-namespaces.i\
	src/bindings/java/local-downcast-extension.i src/bindings/java/local-downcast-namespaces.i src/bindings/java/local-packages.i\
	src/bindings/perl/local-downcast-extension.cpp src/bindings/perl/local-downcast-namespaces.cpp src/bindings/perl/local-downcast-plugins.cpp\
	src/bindings/perl/local-downcast.cpp src/bindings/perl/local-packages.i src/bindings/python/local-downcast-extension.cpp\
	src/bindings/python/local-downcast-namespaces.cpp src/bindings/python/local-downcast-plugins.cpp src/bindings/python/local-downcast.cpp\
	src/bindings/python/local-packages.i src/bindings/ruby/local-downcast-extension.cpp src/bindings/ruby/local-downcast-namespaces.cpp\
	src/bindings/ruby/local-downcast-plugins.cpp src/bindings/ruby/local-downcast.cpp src/bindings/ruby/local-packages.i\
	src/bindings/swig/libsbml-packages.h src/bindings/swig/libsbml-packages.i src/sbml/extension/RegisterExtensions.cxx\
	src/sbml/extension/RegisterExtensions.h\
	config/printJavaDataModel.class macosx/build.sh macosx/libsbml-package.pmdoc/*.xml .pc \
	examples/c++/Makefile examples/c/Makefile examples/csharp/Makefile \
	examples/java/Makefile examples/layout/Makefile macosx/resources/package-intro.txt macosx/resources/package-readme.txt \
	src/bindings/csharp/csharp-files-win/BoundingBox.cs src/bindings/csharp/csharp-files-win/CubicBezier.cs \
	src/bindings/csharp/local-packages.i src/bindings/java/local-downcast-extension.i src/bindings/java/local-packages.i \
	src/bindings/perl/local-downcast-extension.cpp src/bindings/perl/local-downcast-plugins.cpp src/bindings/perl/local-downcast.cpp \
	src/bindings/python/local-downcast-extension.cpp src/bindings/python/local-downcast-namespaces.cpp src/bindings/python/local-downcast.cpp \
	src/bindings/python/local-packages.i src/bindings/ruby/local-downcast-namespaces.cpp src/bindings/ruby/local-downcast-plugins.cpp \
	src/bindings/ruby/local-packages.i src/bindings/swig/libsbml-packages.h src/sbml/extension/RegisterExtensions.cxx src/sbml/extension/RegisterExtensions.h \
	src/bindings/csharp/csharp-files-win/Curve.cs src/bindings/csharp/csharp-files-win/Dimensions.cs \
	src/bindings/csharp/csharp-files-win/GraphicalObject.cs src/bindings/csharp/csharp-files-win/Layout.cs \
	src/bindings/csharp/csharp-files-win/LayoutExtension.cs src/bindings/csharp/csharp-files-win/LayoutModelPlugin.cs \
	src/bindings/csharp/csharp-files-win/LayoutPkgNamespaces.cs src/bindings/csharp/csharp-files-win/LayoutSpeciesReferencePlugin.cs \
	src/bindings/csharp/csharp-files-win/LineSegment.cs src/bindings/csharp/csharp-files-win/ListOfGraphicalObjects.cs \
	src/bindings/csharp/csharp-files-win/ListOfLayouts.cs src/bindings/csharp/csharp-files-win/ListOfLineSegments.cs \
	src/bindings/csharp/csharp-files-win/Point.cs src/bindings/csharp/csharp-files-win/libsbml.cs \
	src/bindings/csharp/csharp-files-win/libsbmlPINVOKE.cs src/bindings/csharp/csharp-files/libsbml.cs \
	src/bindings/csharp/csharp-files/libsbmlPINVOKE.cs src/bindings/csharp/libsbml_wrap-win.cpp \
	src/bindings/csharp/libsbml_wrap.cpp src/bindings/java/Manifest.txt src/bindings/java/java-files/org/sbml/libsbml/BoundingBox.java \
	src/bindings/java/java-files/org/sbml/libsbml/CubicBezier.java src/bindings/java/java-files/org/sbml/libsbml/Curve.java \
